
;; this is called when we are re-awakened from a saved image

(define random-delta 0)

#|
(register-interrupt-handler! 
 6
 (lambda (pid t rc) 
   (format #t "process ~d: ~s ~d\n" pid t rc)))
|#

(define random
  (let ((random random))
    (lambda 'new-random ()
       (+ (random) random-delta))))

(define *process-dir* #f)

(define ($awake)
  (for-each (lambda (thunk) (thunk))
	    $init-thunks)
  (set! *process-dir* (process-directory))
  (let ((p (open-input-process "date")))
    (set! random-delta (string->hash (read-line p)))
    (close-input-port p))
  ;;
  (if (getenv "RS_INSTALL_DIR")
      (set! *dist-install-resource-dir*
	    (string->dir (string-append (getenv "RS_INSTALL_DIR")
					"/resource"))))
  (add-special-root! "[dist]"
		     (make <root-dir>
			   root-name: "[dist]/"
			   expanded-name: (pathname->string *dist-path*))))

;; this is called when we get arguments
;; (but it is NOT called when we don't get arguments)


(define ($process-cmd-line args)
  (let ((sw (car args)))
    (cond
     ((string=? sw "-?")
      (display "usage:\n")
      (display "  rsc file... -- process .mcf's\n")
      (display "  rsc -x -- reload changed files in compiler\n")
      (display "  rsc -o output extra-module... -- link bootable image\n")
      #f)
     ((string=? sw "-repl")
      #t)
     ((string=? sw "-e")
      (eval (with-input-from-string (cadr args) read) *self*)
      ($process-cmd-line (cddr args)))
     ((string=? sw "-exit")
      #f)
     ((string=? sw "-I")
      (set! *dist-install-resource-dir*
	    (append-dirs (string->dir (cadr args))
			 (string->dir "resource")))
      (set! *dist-resource-path*
	    (cons *dist-install-resource-dir*
		  *dist-resource-path*))
      (reinit-library-path)
      ($process-cmd-line (cddr args)))
     ((string=? sw "-L")
      (for-each load (cdr args))
      (%save-self)
      #f)
     ((or (string=? sw "-o")
	  (string=? sw "-o.noconf"))
      (let ((target (cadr args)))
	(if (string=? target "-")
	    (set! target (pathname->string
			  (install-resource-path "system.img"))))
	(set! *modules* (append *modules* (map string->symbol (cddr args))))
	(format #t "building: ~s\n" target)
	(format #t "modules: ~s\n" *modules*)
	(write-bootable-image target)
	;;
	;; construct the configuration files
	;;
	(if (not (string=? sw "-o.noconf"))
	    (create-config-files (map get-ct-module *modules*)))
	#f))
     ((string=? sw "-p")
      ;; package mode
      (fluid-let ((*package-mode* #t))
	(set! $module-makefile
	      "$(INSTALL_DIR)/resource/buildenv/module.mak")
	($process-cmd-line (cdr args))))
     ;;
     ((string=? sw "-rsrc")
      (set! *dist-resource-path*
	    (cons (string->dir (cadr args)) *dist-resource-path*))
      (reinit-library-path)
      ($process-cmd-line (cddr args)))
     ;;
     ((string=? sw "-P")
      ;; package mode, with a new dist dir
      (fluid-let ((*package-mode* #t))
	(set! *dist-path*
	      (string->dir (cadr args)))
	(set! *dist-resource-path*
	      (cons (append-dirs *dist-path* (string->dir "resource"))
		    *dist-resource-path*))
	(reinit-library-path)
	(set! $module-makefile
	      "$(INSTALL_DIR)/resource/buildenv/module.mak")
	($process-cmd-line (cddr args))))
     ;;
     ((string=? sw "-v")
      (set! *tl-report* #t)
      ($process-cmd-line (cdr args)))
     ((string=? sw "-make-recopies")
      (set! *make-copy-mode* #t)
      ($process-cmd-line (cdr args)))
     ((string=? sw "-ccode")
      (fluid-let ((*strategy* 'ccode))
	($process-cmd-line (cdr args))))
     (else
      ;; normal compilation...
      (for-each (lambda (a)
		  (format #t "processing: ~a\n" a)
		  (write-module (mcf-load a)))
		args)
      #f)))) ;; return #f to suppress the starting of a REPL

