##  compiler/resource/buildenv/postambl.mak
##
##    [source]/resource/buildenv/postambl.mak
##
## this is the hand-coded portion of $DIST/Makefile
##

TARGET=install/lib/librs.a

$(TARGET) base: $(SUBPROJ)
	$(RANLIB) $(TARGET)

all:: base install-base shell install-shell

install-base::
	if [ ! -d $(INSTALL_DIR) ] ; then mkdir -p $(INSTALL_DIR) ; fi
	(cd install ; tar -cf - .) | (cd $(INSTALL_DIR) ; tar -xf -)


clean::
	for i in rshell $(SUBPROJECTS) ; do (cd $$i ; make clean) ; done
	rm -f $(TARGET) 

#########################################################################
#
#  The base RScheme shell application
#  (a thin layer that simply provides access to the repl module's
#  Read-Eval-Print loop)
#

shell:: rshell/rs system.img

install-shell:: $(INSTALL_DIR)/resource/system.img \
	  $(INSTALL_DIR)/bin/rs

rshell/rs:: $(INSTALL_DIR)/resource/buildenv/preamble.mak \
	 $(INSTALL_DIR)/lib/librs.a
	cd rshell ; $(MAKE) INSTALL_DIR=$(INSTALL_DIR)

$(INSTALL_DIR)/resource/system.img: system.img
	cp -p system.img $(INSTALL_DIR)/resource

$(INSTALL_DIR)/bin/rs: rshell/rs
	cd rshell ; make INSTALL_DIR=$(INSTALL_DIR) install

#
#  patch the base shell's boot image
#

system.img: tmp/system.bas
	rshell/rs -image tmp/system.bas -c.repl system.img

#########################################################################
#
#  some fasl things
#  (can only run these after installation is complete)
#
RSTORE_MODULES=syscalls unixm rstore calendar sets threads fasl debugger

fasl_rstore::
	INSTALL_DIR=$(INSTALL_DIR) sh pkg/fasl/mkfasl rstore $(RSTORE_MODULES)
	cd rstore ; make INSTALL_DIR=$(INSTALL_DIR)
	cd rstore ; make INSTALL_DIR=$(INSTALL_DIR) install

pkgs::
	cd pkg ; make INSTALL_DIR=$(INSTALL_DIR)

#
#  the module compiler, running from WITHIN this build
#

RSC=$(INSTALL_DIR)/bin/rsc

rsc::
	cd ../compiler ; RS=$(INSTALL_DIR)/bin/rs ./mkrsc $(INSTALL_DIR)
	echo "#!/bin/sh" > $(RSC)
	echo 'if test "$$1" = "-corelib" ; then cb=start ; shift ; else if test "$$1" = "-lowscm" ; then cb=+core ; shift ; else cb=+low ; fi ; fi' >> $(RSC)
	echo "exec $(INSTALL_DIR)/bin/rs -image $(INSTALL_DIR)/tmp/rsc.img -BC $(INSTALL_DIR)/resource/compiler/bytecode/bcgen.scm  -config-basis \$$cb \"\$$@\"" >> $(RSC)
	chmod +x $(RSC)

##
##  this is the end of the hand-coded portion of $DIST/Makefile
##
