/*------------------------------------------------------------------*-C-*-*
 * File:    handc/cfg/gcadapt/rtgc/gcclient.c
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.9
 * Date:    1996.04.30 20:02:22
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: rtgc GC adapater (scheme -> adapter -> gc)
 *------------------------------------------------------------------------*/




#ifdef INCL_SCCSID
char *F38RS_dist_cfg_gcadapt_rtgc_gcclient_sccsid__()
{ return "%Z%%W% 1.9 %G% 20:02:22"; }
#endif /* INCL_SCCSID */

#include <stdio.h>
#include <rscheme/vinsns.h>
#include <rscheme/gcserver.h>
#include <rscheme/linktype.h>
#include <rscheme/runtime.h>
#include <rscheme/smemory.h>
#include <rscheme/osglue.h>
#include <rscheme/intrs.h>

struct module_descr **stable_root_module_ptr;
unsigned stable_root_num;
unsigned quasistable_root_num;

#ifndef INLINES
#include "gcclient1.ci"
#include "gcclient2.ci"
#endif

void gc_now( void )
{
  gc_full_collect(); /* finish current cycle */
  gc_full_collect(); /* do a complete 'nother one */
}

int gc_for_each( int (*fn)( void *info, void *heap_obj ), void *info )
{
  gc_obj_addr p;
  int rc;

  reset_not_known_free_object_iterator();

  while ((p = next_not_known_free_object()))
    {
      rc = fn( info, p );
      if (rc)
	return rc;
    }
  return 0;
}

bool safe_for_is_object_dead( void )
{
  return gc_cycle_finish_ok() ? true : false;
}
