/*------------------------------------------------------------------*-C-*-*
 * File:    handc/cfg/mod.c
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.3
 * Date:    1996.04.18 20:45:42
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: Config file to test behavior of C '%'
 *------------------------------------------------------------------------*/




#ifdef INCL_SCCSID
char *F25RS_dist_cfg_mod_sccsid__()
{ return "%Z%%W% 1.3 %G% 20:45:42"; }
#endif /* INCL_SCCSID */

#include <stdio.h>

/*
    The sign convention for the C operator `%' is
    implementation dependent, so REMDR insulates us from that, and
    promises to use the convention defined by Scheme,
    which apparently is that the remainder always has the sign
    of the dividend (the first argument)

    "Remainder and modulo differ on negative arguments ---
     the remainder is either zero or has the sign of the dividend,
     while the modulo always has the sign of the divisor:"
    
				    -- Revised^4 Scheme, p.22
*/


main()
{
  int a, b;

  a = 13;
  b = 4;

/*
#define REMDR(x,y) ((x)%(y))
#define MOD(x,y) (((x)%(y))+((x)<0?((y)<0?0:y):((y)<0?y:0)))

  printf( "%d %% %d = %d\n",  a,  b, MOD( a, b) );
  printf( "%d %% %d = %d\n", -a,  b, MOD(-a, b) ); 
  printf( "%d %% %d = %d\n",  a, -b, MOD( a,-b) ); 
  printf( "%d %% %d = %d\n", -a, -b, MOD(-a,-b) ); 
*/

  if ((a%b == 1) && (-a%b == -1) && (a%-b == 1) && (-a%-b == -1))
    {
      /* apparently, this system (RS/6000, or something similar),
	 has % take on the sign of the dividend (in dividend % divisor)
      */
      printf("#define REMDR(x,y) ((x)%%(y))\n");
      printf( 
	     "#define MOD(x,y) (((x)%%(y))+((x)<0?((y)<0?0:y):((y)<0?y:0)))\n"
	     );
    }
  else
    {
      fprintf( stderr, "unrecognized `a%%b' style -- defaulting\n" );
  
      printf( "#define UMOD(x,y) ((int)((unsigned)x %% (unsigned)y))\n");
      printf( "#define XFER_SIGN(x,y) ((y < 0) ? -x : x)\n");
      printf( "#define REMDR(x,y) XFER_SIGN(UMOD(x,y),x)\n");
      printf( "#define MOD(x,y) XFER_SIGN(UMOD(x,y),y)\n");
    }
}
