/*------------------------------------------------------------------*-C-*-*
 * File:    handc/heapi/loadboot.c
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.6
 * Date:    1996.06.05 00:54:38
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: load the boot image
 *------------------------------------------------------------------------*
 * Notes:
 *     the function here is designed to be replaced by alternate
 *     boot image loaders, like FASL
 *------------------------------------------------------------------------*/




#ifdef INCL_SCCSID
char *Fb2RS_dist_heapi_loadboot_sccsid__()
{ return "%Z%%W% 1.6 %G% 00:54:38"; }
#endif /* INCL_SCCSID */

#include <rscheme/smemory.h>
#include <rscheme/scheme.h>
#include <rscheme/heapi.h>

obj load_initial_heap( const char *path, obj *pre_args, rs_bool verbose )
{
char *gc_argv[3];
int vers;
obj r;

  gc_argv[0] = "rs";
  gc_argv[1] = verbose ? (char *)NULL : "-q";
  gc_argv[2] = NULL;
  init_gc( verbose ? 1 : 2, (const char **)gc_argv );
  
  /* make room for it... */
  
  gc_safe_point( 1024*1024 );
  r = load_image_file( path, FALSE_OBJ, FALSE_OBJ, &vers );

  if (EQ(r,FALSE_OBJ))
    return FALSE_OBJ;

  switch (vers)
    {
    case FMTV_RSCHEME_0_5:  /* assume it's bootable */
    case FMTV_RSCHEME_0_6_BOOT:
      return r;
    default:
      fprintf( stderr, "%s: image version %d -- not bootable\n",
	       path, vers );
      return FALSE_OBJ;
    }
}
