/*------------------------------------------------------------------*-C-*-*
 * File:    handc/platform/aix/dynlink.c
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.3
 * Date:    1996.04.18 20:48:42
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: AIX dynamic linking interface
 *------------------------------------------------------------------------*/




#ifdef INCL_SCCSID
char *F16RS_dist_platform_aix_dynlink_sccsid__()
{ return "%Z%%W% 1.3 %G% 20:48:42"; }
#endif /* INCL_SCCSID */

#include <stdio.h>
#include <sys/ldr.h>
#include <rscheme/linktype.h>

typedef struct export_table *module_init_fn( void );

void *resolve_link_symbol( void *info, const char *sym )
{
struct export_table *t = (struct export_table *)info;

    assert(t);
    while (t->name)
      {
	if (strcmp(sym,t->name) == 0)
	  return t->value;
	t++;
      }
    return NULL;
}

void *dynamic_link_file( const char *path )
{
module_init_fn *entry_fn;

  /* "." is the library path */

  entry_fn = (module_init_fn *)load( (char *)path, 1, "." );

  if (entry_fn)
    return entry_fn();
  else
    return NULL;
}

void done_resolving( void *info )
{
}

void init_dynamic_link( const char *argv0 )
{
}
