/*------------------------------------------------------------------*-C-*-*
 * File:    handc/platform/irix/dynlink.c
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.2
 * Date:    1996.04.18 20:45:54
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: IRIX dynamic linking interface
 *------------------------------------------------------------------------*/




#ifdef INCL_SCCSID
char *F16RS_dist_platform_irix_dynlink_sccsid__()
{ return "%Z%%W% 1.2 %G% 20:45:54"; }
#endif /* INCL_SCCSID */

#include <stdio.h>
#include <dlfcn.h>
#include <rscheme/linktype.h>

void *resolve_link_symbol( void *dlhandle, const char *sym )
{
  void *fct;

  fct = dlsym(dlhandle, sym);
  
  if (fct == NULL) {
    /* couldn't find symbol */
    return NULL;
  } else
    return fct;
  
}

void *dynamic_link_file( const char *path )
{
  void *dlhandle;

  dlhandle = dlopen(path, RTLD_LAZY);

  if (dlhandle == NULL) {
    /* couldn't open DSO */
    return NULL;
  } else
    return dlhandle;

}

void done_resolving( void *dlhandle )
{
  dlclose(dlhandle);
}

void init_dynamic_link( const char *argv0 )
{
}
