/*------------------------------------------------------------------*-C-*-*
 * File:    handc/platform/mac/mapf.c
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.2
 * Date:    1996.04.18 20:46:41
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: generic (stdio) file access for imageio
 *------------------------------------------------------------------------*/




#ifdef INCL_SCCSID
char *F18RS_dist_platform_com_mapf_sccsid__()
{ return "@(#)dist/platform/com/mapf.c, rscheme, rs-0.6, 1.4 1.3 11/4/95 17:51:43"; }
#endif /* INCL_SCCSID */

#include "mapf.h"
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <rscheme/smemory.h>
#include <rscheme/osglue.h>

struct image_buffer {
    void *block;
    struct image_buffer *next;
};

static struct image_buffer *image_buffers;
static FILE *image_file;

rs_bool mapf_open( const char *path )
{
    image_file = os_fopen( path, "rb" );
    if (!image_file)
    {
	perror( path );
	return NO;
    }
    image_buffers = NULL;
    return YES;
}

void mapf_seek( UINT_32 offset )
{
int rc;

    rc = fseek( image_file, offset, SEEK_SET );
    assert( rc == 0 );
}

void *mapf_read( UINT_32 bytes )
{
struct image_buffer *b = (struct image_buffer *)malloc( sizeof( struct image_buffer ) );
int n;

    b->next = image_buffers;
    image_buffers = b;
    b->block = malloc_aligned_32( bytes );
    assert( b->block );
    n = fread( b->block, 1, bytes, image_file );
    assert( n == bytes );
    return b->block;
}

void mapf_close( void )
{
struct image_buffer *b, *n;

    for (b=image_buffers; b; b=n)
    {
	n = b->next;
	free_aligned_32( b->block );
	free( b );
    }
}

