#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/compiler/classes.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.12
 | Date:    1996.09.11 22:21:06
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: compile-time classes
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.12 %G% 22:21:06")

(define-generic-function lookup)
(define-generic-function bind!)

(define <<target-class>> <<class>>)

;---

(define-class <icode> (<object>)
    (does-lambda? init-keyword: #f
		  init-value: #f)
    (does-save? init-keyword: #f
		init-value: #f)
    (vars-referenced init-value: '())
    (vars-captured init-value: '()))

(define-class <expr-icode> (<icode>)
    (return-types init-value: '(<obj>))
    (mode init-value: 'value))

(define-class <ic-call> (<expr-icode>)
    function
    args)		;; an <ic-multi>

(define-class <ic-call-prim> (<expr-icode>)
    function
    args)

(define-class <ic-prim-expr> (<expr-icode>)
    expr)

(define-class <ic-bind> (<expr-icode>)
    envt
    inits		; #f => bind arguments!
    body
    (num-args init-keyword: #f)  ;; filled in by initializer
    rest?)

(define-class <ic-tl-ref> (<expr-icode>)
    var)
(define-class <ic-lex-ref> (<expr-icode>)
    var)
    

(define-class <ic-root-ref> (<expr-icode>)
    var)



(define-class <ic-tl-set> (<expr-icode>)
    var
    rhs)

(define-class <ic-lex-set> (<expr-icode>)
    var
    rhs)
    
(define-class <ic-root-set> (<expr-icode>)
    var
    rhs)

(define-class <ic-if> (<expr-icode>)
    condition
    if-true
    if-false)

(define-class <ic-const> (<expr-icode>)
    value)

(define-class <ic-procedure> (<icode>)
    name
    body)

(define-class <ic-lambda> (<expr-icode>)
    proc
    (code-properties init-value: '()))

(define-class <ic-multi> (<expr-icode>)
    arg-list)

(define-class <ic-seq> (<expr-icode>)
    stmt-list)

(define-class <ic-loop> (<expr-icode>)
    inits
    envt
    body
    loop-var
    (first-arg-reg init-value: 0)
    (ct-envt init-value: #f))

(define-class <ic-jump> (<icode>)
    args
    loop-var)

(define-generic-function compile-head)
(define-generic-function compile-ref)
(define-generic-function compile-set)

;(define-generic-function set-write-prot!)
;(define-generic-function write-prot)
;(define-generic-function table)
;(define-generic-function set-table!)

(define-class <special-form> (<binding>)
    compiler-description
    (compiler-proc init-value: #f);; cached translation of compiler-description
    (syntax-checker init-value: #f))

(mifio-class "<special-form>" <special-form>)

(define (special-form-compiler (self <special-form>))
  (let ((p (compiler-proc self)))
    (if p
	p
	(begin
	  (set! p (special-form-compiler->proc (compiler-description self)))
	  (set-compiler-proc! self p)
	  p))))

(define-class <lexical-var> (<binding>)
    (envt init-keyword: #f)  ;; this is the envt the var LIVES IN
    type
    (trust-me-type? init-value: #f)
    (ever-set? init-value: #f))

(define-class <loop-var> (<binding>)
    label
    compile-with-full-semantics
    loop-icode)

(define-class <substitution-site-record> (<scope-record>)
  lexical-enclosing
  dynamic-enclosing
  some-info)
