#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/compiler/consts.scm
 |
 |          Copyright (C)1996 Donovan Kolbly <d.kolbly@rosette.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.2
 | Date:    1996.07.11 00:54:47
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: Manipulate compile-time constant expressions
 `------------------------------------------------------------------------|#

(define (compile-time-const? (ic <icode>))
  (instance? ic <ic-const>))

(define (compile-time-const-value (ic <icode>))
  (value ic))

;; class-constant? checks it's argument (<icode>) for the property
;; of being a compile-time constant whose value is a class.
;;
;; in the current implementation, certain syntactic positions
;; in the object system are required to be class constants,
;; such as the superclasses of class and type declaration forms

(define (const-tlv? b)
  (let ((a (actual-bdg b)))
    (and (instance? a <top-level-var>)
	 (write-prot a))))

(define (class-tlv? b)
  (and (const-tlv? b)
       (class? (value (actual-bdg b)))))

(define (class-constant? (ic <icode>))
  (and (instance? ic <ic-tl-ref>)
       (class-tlv? (var ic))))

(define (parse-const-expr expr lex-envt dyn-envt)
  (let ((ic (fold-const (compile expr lex-envt dyn-envt 'value))))
    (if (compile-time-const? ic)
	(value ic)
	(error/semantic "expression is not ct-constant: ~s" expr))))

(define (fold-const (ic <icode>))
  (if (and (instance? ic <ic-tl-ref>)
	   (const-tlv? (actual-bdg (var ic))))
      (make-const (xform (var ic) 'value) (mode ic))
      ic))

	   