#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/corelib/imageio.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.5
 | Date:    1996.06.04 00:38:44
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: image reading and writing (old 0.5 format)
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.5 %G% 00:38:44")


(define-glue (save-image path entry refs options)
{
extern void save_image_file( const char *the_path, 
			     obj the_entry,
			     obj the_refs,
			     obj opt );

    if (arg_count_reg == 3)
      options = FALSE_OBJ;
    else
      COUNT_ARGS(4);

    save_image_file( string_text(path), 
		     entry,
		     refs,
		     options );
    RETURN0();
})

(define-glue (load-image path link options)
{
extern obj load_image_file( const char *the_path, 
			    obj the_link_table,
			    obj opt, int *vers );
int v;

    if (arg_count_reg == 2)
      options = FALSE_OBJ;
    else
      COUNT_ARGS(3);

    REG0 = load_image_file( string_text(path), link, options, &v );
    REG1 = int2fx(v);
    RETURN(2);
})

(define-glue (image-write-header path hdr)
{
extern FILE *os_fopen( const char *f_path, const char *mode );
FILE *f = os_fopen( string_text(path), "r+b" );
UINT_32 n;
#define FILE_HDR_OFFSET (128)

    fseek( f, 0L, SEEK_SET );
    n = SIZEOF_PTR(hdr);
    if (n > FILE_HDR_OFFSET)
        n = FILE_HDR_OFFSET;
    fwrite( PTR_TO_DATAPTR(hdr), 1, n, f );
    fclose(f);
    REG0 = int2fx( n );
    RETURN1();
#undef FILE_HDR_OFFSET
})

(define-glue (image-read-header path)
{
extern FILE *os_fopen( const char *f_path, const char *mode );
FILE *f = os_fopen( string_text(path), "r+b" );
long n;
#define FILE_HDR_OFFSET (128)

    fseek( f, 0L, SEEK_SET );
    REG0 = bvec_alloc( FILE_HDR_OFFSET+1, string_class );
    n = fread( PTR_TO_DATAPTR(REG0), 1, FILE_HDR_OFFSET, f );
    fclose(f);
    REG2 = int2fx(n);
    RETURN(2);
#undef FILE_HDR_OFFSET
})
