#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/highscm/profiler.scm
 |
 |          Copyright (C)1997 Donovan Kolbly <d.kolbly@rosette.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.2
 | Date:    1997.01.15 00:17:36
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: user-level profiling operator
 `------------------------------------------------------------------------|#

(define (call-with-profiling path thunk)
  (%profile-start path)
  (thunk)
  (%profile-stop)
  ;;
  (let ((tbl (make-object-table)))
    (%profile-objects path tbl)
    (let ((f (fopen path "a")))
      (table-for-each
       tbl
       (lambda (h k v)
	 (fputc f #\=)
	 (fwrite/str f (%profile-object-tag k))
	 (let ((nm (name k)))
	   (if (symbol? nm)
	       (set! nm (symbol->string nm)))
	   (if (> (string-length nm) 255)
	       (set! nm (substring nm 0 255)))
	   (fputc f (integer->char (string-length nm)))
	   (fwrite/str f nm))))
      (fclose f))))
