#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/highscm/promise.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.3
 | Date:    1996.04.18 20:25:22
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: delay and force
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.3 %G% 20:25:22")



(define-class <promise> (<object>)
  compute-using
  (computed-value init-value: #f))

(define (force (promise <promise>))
  (let ((thunk (compute-using promise)))
    (if thunk
	(begin
	  (set-compute-using! promise #f)
	  (set-computed-value! promise (thunk))))
    (computed-value promise)))

(define-syntax (delay expr)
  (make <promise>
	compute-using: (lambda () expr)))

(define-method write-object ((self <promise>) port)
  (if (compute-using self)
      (format port "#[<promise>]")
      (format port "#[<promise> fulfilled]")))
