/*------------------------------------------------------------------*-C-*-*
 * File:    modules/iolib/cports.h
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.3
 * Date:    1996.04.18 20:34:02
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: Provide interface to C-implemented ports (string ports)
 *------------------------------------------------------------------------*/







#ifndef _H_CPORTS
#define _H_CPORTS

#include <string.h>

/* 
 * String Output Ports 
 */

obj SOP_close( obj port );
void SOP_write( obj port, const char *src, UINT_32 len );

#define SOP_BUFFER    SLOT(0)
#define SOP_INDEX     SLOT(1)
#define SOP_OVERFLOW  SLOT(2)


/* 
 *  Bounded-String Output Ports 
 */

rs_bool BSOP_write( obj port, const char *src, UINT_32 len );
obj BSOP_close( obj port );

#define BSOP_BUFFER    SLOT(0)
#define BSOP_INDEX     SLOT(1)


/* Output string conversion
 * 
 *  stores its results directly into REG0 and REG1
 */

extern void printablize_string( obj str, obj str_index );

/* Format string parsing
 */

obj parse_format_string( obj str );

#endif /* _H_CPORTS */
