#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/iolib/filter.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.3
 | Date:    1996.04.18 20:36:02
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: provide output-port filters
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.3 %G% 20:36:02")



(define-class <output-filter> (<output-port>)
  filter-proc
  destination-port)

(define-method output-port-write-char ((self <output-filter>) ch)
  (let ((f ((filter-proc self) (string ch)))
	(n (destination-port self)))
    (if (char? f)
	(output-port-write-char n f)
	(if (string? f)
	    (write-string n f)
	    (error "filter port: filter proc returned invalid ~s" f)))))

(define-method write-string ((self <output-filter>) str)
   (let ((f ((filter-proc self) str))
	(n (destination-port self)))
    (if (char? f)
	(output-port-write-char n f)
	(if (string? f)
	    (write-string n f)
	    (error "filter port: filter proc returned invalid ~s" f)))))
 
(define (make-output-filter port proc)
  (make <output-filter>
	filter-proc: proc
	destination-port: port))

