#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/iolib/strin.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.3
 | Date:    1996.04.18 20:35:41
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: Implement string-input-ports
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.3 %G% 20:35:41")



(define-class <string-input-port> (<input-port>)
  string-port-contents
  (string-port-offset init-value: 0))

(define (open-input-string (source <string>))
  (make <string-input-port>
	string-port-contents: source))

(define-method input-port-read-char ((self <string-input-port>))
  (let (((contents <string>) (string-port-contents self))
	((i <fixnum>) (string-port-offset self)))
    (if (fixnum<? i (string-length contents))
	(let ((c (string-ref contents i)))
	  (set-string-port-offset! self (add1 i))
	  c)
	$eof-object)))

(define-method input-port-peek-char ((self <string-input-port>))
  (let (((contents <string>) (string-port-contents self))
	((i <fixnum>) (string-port-offset self)))
    (if (fixnum<? i (string-length contents))
	(string-ref contents i)
	$eof-object)))

(define-method close-input-port ((self <string-input-port>))
  (set-string-port-contents! self "")
  (set-string-port-offset! self 0))
