#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/lowscm/grokking.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.5
 | Date:    1996.06.04 00:38:54
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: general lower level list operations
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.5 %G% 00:38:54")


; List Access Functions



; c[ad]^2r

(define (caar x) (car (car x)))
(define (cadr x) (car (cdr x)))
(define (cddr x) (cdr (cdr x)))
(define (cdar x) (cdr (car x)))

; c[ad]^3r

(define (caaar x) (car (car (car x))))
(define (caadr x) (car (car (cdr x))))
(define (caddr x) (car (cdr (cdr x))))
(define (cadar x) (car (cdr (car x))))

(define (cdaar x) (cdr (car (car x))))
(define (cdadr x) (cdr (car (cdr x))))
(define (cdddr x) (cdr (cdr (cdr x))))
(define (cddar x) (cdr (cdr (car x))))

; c[ad]^4r

(define (caaaar x) (car (car (car (car x)))))
(define (caaadr x) (car (car (car (cdr x)))))
(define (caaddr x) (car (car (cdr (cdr x)))))
(define (caadar x) (car (car (cdr (car x)))))

(define (cadaar x) (car (cdr (car (car x)))))
(define (cadadr x) (car (cdr (car (cdr x)))))
(define (cadddr x) (car (cdr (cdr (cdr x)))))
(define (caddar x) (car (cdr (cdr (car x)))))

(define (cdaaar x) (cdr (car (car (car x)))))
(define (cdaadr x) (cdr (car (car (cdr x)))))
(define (cdaddr x) (cdr (car (cdr (cdr x)))))
(define (cdadar x) (cdr (car (cdr (car x)))))

(define (cddaar x) (cdr (cdr (car (car x)))))
(define (cddadr x) (cdr (cdr (car (cdr x)))))
(define (cddddr x) (cdr (cdr (cdr (cdr x)))))
(define (cdddar x) (cdr (cdr (cdr (car x)))))

; other stuff

(define (ok-so-far seen item)
  (and (pair? item)
       (not (memq item seen))))

(define (list? x)
  (let loop ((l x) (a '()))
    (if (ok-so-far a l)
	(let ((l (cdr l)))
	  (if (ok-so-far a l)
	      (let ((l (cdr l)))
		(if (ok-so-far a l)
		    (let ((l (cdr l)))
		      (if (ok-so-far a l)
			  (loop (cdr l) (cons l a))
			  (null? l)))
		    (null? l)))
	      (null? l)))
	(null? l))))

(define (last-pair x)
  (if (pair? x)
      (let loop (((t <pair>) x))
	(let ((c (cdr t)))
	  (if (pair? c)
	      (loop c)
	      (if (null? c)
		  t
		  (error "last-pair: not a list at: ~s" t)))))
      (error "last-pair: not a pair to start: ~s" x)))

(define (append! target . new-tails)
  (let loop ((t new-tails)
	     (p target))
    (if (null? t)
	target
	(let ((new-tail (car t)))
	  (if (null? new-tail)
	      (loop (cdr t) p)
	      (begin
		(set-cdr! (last-pair p) new-tail)
		(loop (cdr t) new-tail)))))))

#|
(define (append! target new-tail)
  (if (pair? target)
      (let loop (((t <pair>) target))
	(let ((c (cdr t)))
	  (if (pair? c)
	      (loop c)
	      (if (null? c)
		  (begin
		    (set-cdr! t new-tail)
		    target)
		  (error "append!: argument not a proper list: ~s" target)))))
      (if (null? target)
	  new-tail
	  (error "append!: argument not a proper list: ~s" target))))
|#

(define (last l)
  (car (last-pair l)))

(define (length l)
  (let loop ((l l) ((i <fixnum>) 0))
    (if (pair? l)
	(loop (cdr l) (add1 i))
	(if (null? l)
	    i
	    (error "length: not a list at # ~d: ~s" i l)))))

(define (list-tail x (n <fixnum>))
  (let loop ((l x) ((i <fixnum>) n))
    (if (eq? i 0)
	l
	(if (pair? l)
	    (loop (cdr l) (sub1 i))
	    (error "list-tail: list too short: ~d missing at ~s"
		   i l)))))

(define (list-ref list k)
    (car (list-tail list k)))

(define (list-set! list k value)
  (let ((the-tail (list-tail list k)))
    (if (pair? the-tail)
	(let ((old (car the-tail)))
	  (set-car! the-tail value)
	  old)
	(error "list-set!: list too short or not proper: ~d in ~s"
	       k list))))

