#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/mlink/modules.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.7
 | Date:    1996.06.29 20:44:59
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: <module> definition
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.7 %G% 20:44:59")


#|
The link-names of a module is the list of names by which its component
module descriptors (struct module_descr) are known.  descriptor is
known.  That is, if a link-name is "foo", then the <module> uses a
section of code with a module descriptor named "module_foo" This is
used to support dynamic linking.  Each link-name is also the name
stored in the module_descr.  If no C code/data is required to support
this module, then link-names is ()
|#

;;************* ATTENTION *************
;;
;;  this structure is duplicated in compiler/mlink/modules.scm
;;  SYNCHRONIZATION MUST BE MAINTAINED
;;

(define-class <module> (<object>)
    (link-names init-value: '() 
		type: <list>) ;; list of C entries that form the module
                            ;; (they get accumulated when linking up)
                            ;; () if no C context is required/available
    (proj-names init-value: '() 
		type: <list>) ;; list of C subprojects that form the module
    top-level-envt          ;; may be #f if not published
    (module-imports init-value: '()
		    type: <list>)  ;; a list of <imported-module>'s
    (module-exports init-value: '#uninit 
		    type: <table>)
    (module-shares init-value: '() 
		   type: <list>)  ;; list of shared exports
    (module-permits-writing init-value: '()
			    type: <list>) ;; list of writable exports
    (module-classes init-value: '() 
		    type: <list>)   ;; classes defined by this module
    (module-generic-functions init-value: '() 
			      type: <list>)  ;; GFs built in here
    (module-implicit-methods init-value: '() 
			     type: <list>)   ;; getters & setters
    (module-bytecode-extensions init-value: '() 
				type: <list>)  ;; bytecode extensions
    (init-thunks init-value: '()
		 type: <list>))   ;; initialization thunks

(define-class <imported-module> (<object>)
  owner    ;; the module we belong to
  actual-module ;; the actual module we represent
  (name init-value: '#uninit type: <symbol>)
  ;; a list of <link-cmd> general instances
  ;; which are processed, at link time, in-order
  ;; so <link-bdgs> is first, followed by any <link-value>'s,
  ;; followed by any others
  (link-commands init-value: '() type: <list>))

(mifio-class "<module>" <module>)
(mifio-class "<imported-module>" <imported-module>)
(mifio-class "<symbol-table>" <symbol-table>)

