#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/mlink/seq.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.3
 | Date:    1996.04.18 20:21:56
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: <seq> objects (tail-growing lists)
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.3 %G% 20:21:56")

(define-class <seq> (<object>)
  (first allocation: internal) 
  (last allocation: internal))

(define-method initialize ((self <seq>))
  (let ((i (cons 0 '())))
    (gvec-set! self 0 i)
    (gvec-set! self 1 i)
    self))

(define (make-seq)
  (make <seq>
	first: #f
	last: #f))

(define (seq-add! (seq <seq>) item)
  (let* ((the-item item)
	 (i (cons the-item '())))
    (set-cdr! (gvec-ref seq 1) i)
    (gvec-set! seq 1 i)
    the-item))

(define (seq->list (seq <seq>))
    (cdr (gvec-ref seq 0)))

(define (seq-empty? (seq <seq>))
  (null? (cdr (gvec-ref seq 0))))

