#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/paths/filesys.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.6
 | Date:    1997.01.25 12:04:23
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: User-level interface to the file system
 |------------------------------------------------------------------------|
 | Notes:
 |     These functions take <*-name> arguments and translate them
 |     for use by the underlying OS
 `------------------------------------------------------------------------|#

(define (file-exists? path)
  (os-file-exists? (pathname->os-path path)))

(define (chdir path)
  (os-setwd! path)
  ;; flush the "getwd" cache
  (set! *process-dir* #f)
  path)

(define (within-directory (dir <directory-name>) thunk)
  (fluid-let ((*current-dir* dir))
    (thunk)))
