#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/start/present.scm
 |
 |          Copyright (C)1996 Donovan Kolbly <d.kolbly@rosette.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.2
 | Date:    1997.01.26 11:24:28
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: Presentation banners
 `------------------------------------------------------------------------|#

;;
;; this flag is on (#t) by default -- a `-q' flag will cause it
;; to be set to #f by the `start' function
;;

(define *verbose* #t)

;;

(define *program* "RScheme")

;; `*version*' is really filled in at link time
(define *version* "RScheme (v0.7-0.9, 97.01.26)")

(define *license* "\nCopyright (C) 1995-1997 Donovan Kolbly <d.kolbly@rosette.com>\nRScheme comes with ABSOLUTELY NO WARRANTY.\n")

(define (set-presentation! program version license)
  (set! *program* program)
  (set! *version* version)
  (set! *license* license)
  (values))

;; display the program name, version, and date,
;; and general license info
;;
;; we use the low-level stdio functions because
;; the high-level stuff hasn't been set up yet
;; (the high-level i/o library is set up by the initialization procs,
;; which at this point haven't been run yet)
;;
;; this is called by `start' if the system is not invoked in "quiet" mode

(define (greeting)
  (let ((s (stdout)))
    (fwrite/str s *version*)
    (if *license*
	(fwrite/str s *license*)
	(fwrite/str s "\n"))))
