#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/start/start.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.6
 | Date:    1996.07.25 17:34:49
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: Provide the entry point procedure
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.6 %G% 17:34:49")


(define *script* #f)

;;

;; the args passed here are the ones with low-level flags
;; like -image, -q, -script
;; already parsed out (so we don't have to)
;;
;; the "raw" args are available in boot_args rscheme_global[1]

(define-syntax (get-boot-args)
  (rscheme-global-ref 1))

(define-syntax (get-boot-image)
  (rscheme-global-ref 0))

;;;
;;;  note that before we run the initialization thunks, any
;;;  top-level defines with non-constant right-hand-sides
;;;  are not initialized, like $standard-output-port, for example
;;;

(define (start args verbose-flag script-flag)
  ;;
  (set! *verbose* verbose-flag)
  (set! *script* script-flag)
  ;;
  (let ((info (get-boot-image)))
    ;;
    ;; greet the user if not running silently
    ;;
    (if verbose-flag
	(greeting))
    ;;
    ;; run the initialization thunks
    ;;
    (call-thunks (gvec-ref info 3))
    ;;
    ;; call the "main" program
    ;;
    ((gvec-ref info 4) args)))

(define (call-thunks (lst <pair>))
  (let loop (((inits <pair>) lst))
    ((car inits))
    (if (pair? (cdr inits))
	(loop (cdr inits)))))
