#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/tables/classes.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.3
 | Date:    1996.04.18 20:26:49
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: table classes
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.3 %G% 20:26:49")

;; introspection

(define-generic-function table-hash-function)
(define-generic-function table-equal-function)

(define-generic-function table-size)
;(define-generic-function table-keys->list)
;(define-generic-function table-values->list)

;;

(define-class <table-bucket> (<object>)
    bucket-bits
    bucket-overflow)

;; there may be other kinds of tables, like explicit alists
;; or even DBM covers (which really are hash tables, I think,
;; but in a vendor library)
;;
;;  a <table> maps keys onto values

(define-class <table> (<object>) :abstract)

(define-class <hash-table> (<table>)
    (directory init-keyword: #f)
    (directory-bits init-value: 4)
    (table-size init-value: 0 init-keyword: #f)
    (bucket-class init-value: #f))

;; operations

(define-generic-function table-lookup)
(define-generic-function table-insert!)
(define-generic-function table-remove!)
(define-generic-function table-key-present?)

(define-generic-function value-sequence)
(define-generic-function key-sequence)		;; DIRM p.129
#|
(define-generic-function element)		;; DIRM p.128
|#

(define-generic-function table-for-each)
