#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/tables/join.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.3
 | Date:    1996.04.18 20:26:21
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: hash join function for tables
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.3 %G% 20:26:21")


(define (table-join a b a-only b-only a-and-b)
  (if (not (and (eq? (table-equal-function a)
		     (table-equal-function b))
		(eq? (table-hash-function a)
		     (table-hash-function b))))
      (error "table-join: incommensurate tables given: ~s and ~s" a b)
      (let* ((eq-fn (table-equal-function a))
	     (union (make-table eq-fn (table-hash-function a))))
	(table-for-each
	 a
	 (lambda (h k v)
	   (let ((bv (table-lookup b k)))
	     (if bv
		 (begin
		   (if a-and-b
		       (a-and-b k v k bv))
		   (table-insert! union k #t))
		 (begin
		   (if a-only
		       (a-only k v)))))))
	(table-for-each
	 b
	 (lambda (h k v)
	   (if (not (table-lookup union k))
	       (begin
		 (if b-only
		     (b-only k v)))))))))
