#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/tables/make.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.3
 | Date:    1996.04.18 20:26:36
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: initializers for <hash-table>'s
 `------------------------------------------------------------------------|#



;;(file-version-string "%Z%%W% 1.3 %G% 20:26:36")



(define-method initialize ((self <hash-table>))
  (set-bucket-class! self <table-bucket>)
  (set-directory! self (make-vector (shift-left 1 (directory-bits self))))
  self)

#|
(define $log2-tree '#(128 #(8 #(2 #(1 0 1)
				  #(4 2 3))
			      #(32 #(16 4 5)
			           #(64 6 7)))
			  #(2048 #(512 #(256 8 9)
			               #(1024 10 11))
				 #(8192 #(4096 12 13)
				        #(16384 14 15)))))
				   

(define (binary-search tree (value <fixnum>))
    (if (fixnum? tree)
	tree
	(let (((t <vector>) tree))
	    (if (<= value (vector-ref t 0))
		(binary-search (vector-ref t 1) value)
		(binary-search (vector-ref t 2) value)))))
|#

(define (log2 (n <fixnum>))
    (let loop (((i <fixnum>) 1) ((j <fixnum>) 0))
	(if (fixnum>=? i n)
	    j
	    (loop (shift-left i 1) (add1 j)))))

(define (capacity->directory-size cap)
    (if cap (log2 cap) 4))

(define (make-table eq-proc hash-proc . cap)
    (let ((initial-size (capacity->directory-size 
			    (if (null? cap) 
				#f 
				(car cap)))))
	(cond
	    ((and (eq? eq-proc string=?)
		  (eq? hash-proc string->hash))
		(make <string-table> directory-bits: initial-size))
	    ((and (eq? eq-proc string-ci=?)
		  (eq? hash-proc string-ci->hash))
		(make <string-ci-table> directory-bits: initial-size))
	    ((and (eq? eq-proc eq?)
		  (eq? hash-proc symbol->hash))
		(make <symbol-table> directory-bits: initial-size))
	    ((and (eq? eq-proc eq?)
		  (eq? hash-proc identity))
	        (make <integer-table> directory-bits: initial-size))
	    ((and (eq? eq-proc eq?)
		  (eq? hash-proc integer->hash))
	        (make <hash-integer-table> directory-bits: initial-size))
	    ((eq? eq-proc eq?)
		(make <eq-table> directory-bits: initial-size
				 table-hash-function: hash-proc))
	    (else
		(make <generic-table> directory-bits: initial-size
				      table-hash-function: hash-proc
				      table-equal-function: eq-proc)))))

;; convenience function

(define (make-symbol-table)
  (make <symbol-table>
	directory-bits: 4))

(define (table? thing)
    (instance? thing <table>))

(define-safe-glue (hash-table-copy (table <hash-table>))
{
  REG0 = hashtable_copy(table);
  RETURN1();
})
