#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/tables/patch.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.6
 | Date:    1996.07.10 19:56:53
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: table patchup (relevant to 0.5 --> 0.6 migration)
 `------------------------------------------------------------------------|#

;;(file-version-string "%Z%%W% 1.6 %G% 19:56:53")

;;
;;  we need to reconstruct our symbol table, because the link
;;  process drops the symbol table (though the linker could, with
;;  a little extra weak-pointer-like effort, construct the true
;;  symbol table)

(define (patch-symbols)
  (let*(((v <vector>) (all-instances <symbol>))
	(tbl (rscheme-global-ref 2)))
    (let loop (((i <fixnum>) (vector-length v)))
      (if (eq? i 0)
	  (values)
	  (let* (((sym <symbol> :trust-me) (vector-ref v (sub1 i)))
		 ((str <string>) (symbol->string sym)))
	    (table-install! tbl (string->hash str) str sym)
	    (loop (sub1 i)))))))
