#|------------------------------------------------------------*-Scheme-*--|
 | File:    modules/tables/symtable.scm
 |
 |          Copyright (C)1997 Donovan Kolbly <d.kolbly@rosette.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.4
 | Date:    1997.01.13 15:53:49
 | Build:   v0.7-0.9, 97.01.26
 |
 | Purpose: symbol-table (ie, hash table with symbol keys) implementation
 `------------------------------------------------------------------------|#

(define-class <symbol-table> (<hash-table>))

(define-method table-key-present? ((self <symbol-table>) (key <symbol>))
  (object-table-probe? self (symbol->hash key) key))

(define-method table-lookup ((self <symbol-table>) (key <symbol>))
  (object-table-lookup self (symbol->hash key) key))

(define-method table-remove! ((self <symbol-table>) (key <symbol>))
  (object-table-remove! self (symbol->hash key) key))

(define-method table-insert! ((self <symbol-table>) (key <symbol>) value)
  (object-table-insert! self (symbol->hash key) key value))

;; introspection

(define-method table-hash-function ((self <symbol-table>))
  symbol->hash)
    
(define-method table-equal-function ((self <symbol-table>))
  eq?)
