(define *unix-signals*
  '#((SIGHUP 1 "hangup, generated when terminal disconnects")
     (SIGINT 2 "interrupt, generated from terminal special char")
     (SIGQUIT 3 "quit, generated from terminal special char")
     (SIGILL 4 "illegal instruction (not reset when caught)")
     (SIGTRAP 5 "trace trap (not reset when caught)")
     (SIGABRT 6 "abort process")
     (SIGEMT 7 "EMT intruction")
     (SIGFPE 8 "floating point exception")
     (SIGKILL 9 "kill (cannot be caught or ignored)")
     (SIGBUS 10 "bus error (specification exception)")
     (SIGSEGV 11 "segmentation violation")
     (SIGSYS 12 "bad argument to system call")
     (SIGPIPE 13 "write on a pipe with no one to read it")
     (SIGALRM 14 "alarm clock timeout")
     (SIGTERM 15 "software termination signal")
     (SIGURG 16 "urgent contition on I/O channel")
     (SIGSTOP 17 "stop (cannot be caught or ignored)")
     (SIGTSTP 18 "interactive stop")
     (SIGCONT 19 "continue (cannot be caught or ignored)")
     (SIGCHLD 20 "sent to parent on child stop or exit")
     (SIGTTIN 21 "background read attempted from control terminal")
     (SIGTTOU 22 "background write attempted to control terminal")
     (SIGIO 23 "I/O possible, or completed")
     (SIGXCPU 24 "cpu time limit exceeded (see setrlimit)")
     (SIGXFSZ 25 "file size limit exceeded (see setrlimit)")
     (SIGMSG 27 "input data is in the HFT ring buffer")
     (SIGWINCH 28 "window size changed")
     (SIGPWR 29 "power-fail restart")
     (SIGUSR1 30 "user defined signal 1")
     (SIGUSR2 31 "user defined signal 2")
     (SIGPROF 32 "profiling time alarm (see setitimer)")
     (SIGDANGER 33 "system crash imminent; free up some page space")
     (SIGVTALRM 34 "virtual time alarm (see setitimer)")
     (SIGMIGRATE 35 "migrate process (see TCF)")
     (SIGPRE 36 "programming exception")
     (SIGVIRT 37 "AIX virtual time alarm")
     (SIGGRANT 60 "HFT monitor mode granted")
     (SIGRETRACT 61 "HFT monitor mode should be relinguished")
     (SIGSOUND 62 "HFT sound control has completed")
     (SIGSAK 63 "secure attention key")))
