/*-----------------------------------------------------------------*-C-*---
 * File:    handc/cfg/gcadapt/irc/gcclient.c
 *
 *          Copyright (C)1995,1997 Donovan Kolbly <d.kolbly@rosette.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.4
 * Date:    1997.01.07 16:13:39
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: IRC GC adapater (scheme -> adapter -> gc)
 *------------------------------------------------------------------------*/

#ifdef INCL_SCCSID
char *F39RS_dist_cfg_gcadapt_irc_gcclient_sccsid__()
{ return "%Z%%W% 1.4 %G% 16:13:39"; }
#endif /* INCL_SCCSID */

#include <rscheme/clientyp.h>
#include <rscheme/traverse.h>

#include <rscheme/vinsns.h>
#include <rscheme/gcserver.h>
#include <rscheme/linktype.h>
#include <rscheme/runtime.h>
#include <rscheme/smemory.h>
#include <rscheme/gcconfig.h>
#include <stdio.h>

IRC_Heap *gc_arena;
INT_32 gc_alloc_time;

#ifndef INLINES
#include "gcclient1.ci"
#include "gcclient2.ci"
#endif

void IRC_clientWriteViolation( IRC_Heap *heap, void *item, UINT_32 offset )
{
  scheme_error( "~s: write protected", 1, OBJ(((UINT_32)item)+POINTER_TAG) );
}

INT_32 left = 0;

void init_gc( int argc, const char **argv )
{
  gc_arena = IRC_newHeap();
  gc_alloc_time = 500000;
}

int gc_for_each( int (*fn)( void *info, void *heap_obj ), void *info )
{
  return IRC_forEachObject( gc_arena, fn, info );
}

void gc_now( void )
{
   IRC_fullCollect( gc_arena, NUM_GENERATIONS );
}
