/*------------------------------------------------------------------*-C-*-*
 * File:    handc/heapi/saveq.h
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.3
 * Date:    1996.04.18 20:39:54
 * Build:   v0.7-0.9, 97.01.26
 *
 *------------------------------------------------------------------------*/





/* a very primitive SaveQueue implementation */

/* network canonicalization function
   (in case it's not PLATFORM_IS_BIG_ENDIAN) */

typedef void *ncanonicalize_fn( void * );


struct SaveQueue_item {
    struct SaveQueue_item *next;
    char data[4];
};

typedef struct {
    struct SaveQueue_item *front;
    struct SaveQueue_item *tail;
    unsigned item_size;
    ncanonicalize_fn *netcanon_fn;
} SaveQueue;

typedef struct {
    SaveQueue *q;
    struct SaveQueue_item *p;
} SaveQueueIterator;

void init_queue( SaveQueue *q, unsigned item_size, ncanonicalize_fn *nc );
void *enqueue_item( SaveQueue *q );

void init_queue_state( SaveQueueIterator *state, SaveQueue *q );
const void *dequeue_item( SaveQueueIterator *state );

unsigned fwrite_queue_contents( SaveQueue *q, FILE *f );
void free_queue( SaveQueue *q );
