/*------------------------------------------------------------------*-C-*-*
 * File:    handc/platform/sunos/dynlink.c
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.4
 * Date:    1996.08.03 14:08:24
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: SunOS dynamic linking interface
 *------------------------------------------------------------------------*/

#ifdef INCL_SCCSID
char *F19RS_dist_platform_sunos_dynlink_sccsid__()
{ return "%Z%%W% 1.4 %G% 14:08:24"; }
#endif /* INCL_SCCSID */

#include <stdio.h>
#include "dynlink.h"

#ifdef HAVE_LIBDL
#include <dlfcn.h>
#endif

void *resolve_link_symbol( void *info, const char *sym )
{
#if HAVE_LIBDL
    return dlsym( info, sym );
#else
    return NULL;
#endif
}

void *dynamic_link_file( const char *path )
{
#if HAVE_LIBDL
    return dlopen( path, 1 );
#else
    return NULL;
#endif
}

void done_resolving( void *info )
{
}

void init_dynamic_link( const char *argv0 )
{
}


