/*------------------------------------------------------------------*-C-*-*
 * File:    handc/rshell/shell.c
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.8
 * Date:    1996.08.03 21:39:47
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: Trivial "shell" application
 *------------------------------------------------------------------------*/

#ifdef INCL_SCCSID
char *F50RS_dist_rshell_shell_sccsid__()
{ return "%Z%%W% 1.8 %G% 21:39:47"; }
#endif /* INCL_SCCSID */

#include <stdlib.h>
#include <stdio.h>
#include <rscheme/api.h>
#include <rscheme/stdmodul.h>
#include <rscheme/rlseconf.h>

#ifdef PLATFORM_MAC_CODEWARRIOR
#include <stdio.h>
#include <sioux.h>
#endif

struct module_descr *(std_modules[]) = { STD_MODULES_DECL };

int main( int argc, const char **argv )
{
#ifdef PLATFORM_MAC_CODEWARRIOR
  /* configure the I/O window */
  SIOUXSettings.autocloseonquit = TRUE;
  SIOUXSettings.asktosaveonclose = TRUE;
#endif

  rs_install_dir = getenv( "RS_INSTALL_DIR" );
  if (!rs_install_dir)
    rs_install_dir = INSTALL_DIR;

#ifdef PLATFORM_MAC
  return rscheme_std_main( argc, argv, std_modules, "install/system.img" );
#else
  {
    char temp[1024];

    sprintf( temp, "%s/resource/system.img", rs_install_dir );
    return rscheme_std_main( argc, argv, std_modules, temp );
  }
#endif
}
