/*------------------------------------------------------------------*-C-*-*
 * File:    handc/runtime/linkage.c
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.5
 * Date:    1996.04.18 20:51:19
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: C-Module utility functions
 *------------------------------------------------------------------------*/




#ifdef INCL_SCCSID
char *F12RS_dist_runtime_linkage_sccsid__()
{ return "%Z%%W% 1.5 %G% 20:51:19"; }
#endif /* INCL_SCCSID */

#include <string.h>
#include <stdlib.h>
#include <rscheme/runtime.h>
#include <rscheme/smemory.h>
#include <rscheme/scheme.h>
#include <rscheme/allocns.h>

#if 0
#ifdef INLINES
#include "gcclient1.ci"
#include "gcclient2.ci"
#else
#include <rscheme/gcclient.h>
#endif
#endif

struct module_descr **master_table = NULL;
static rs_bool original_modules = YES;
    
#define IGNORE_FAULTS

void init_linkage( struct module_descr **initial_table )
{
    struct module_descr **m;

    master_table = initial_table;

    /* install any bytecode extensions that are in the initial
       set (statically linked) of modules */
       
    for (m=master_table; *m; m++)
      {
	unsigned i, n;
	struct module_descr *m1 = (*m);

	n = m1->num_bc_extensions;
	for (i=0; i<n; i++)
	  install_bc_extension( &m1->bc_extensions[i] );
      }

#ifdef GNU_VINSNS
    {
    struct module_descr **m;
    struct part_descr **p;
    struct function_descr **f;
    
	for (m=master_table; *m; m++)
	{
	    for (p=(*m)->parts; *p; p++)
	    {
		/*
		printf( "Fixing up %s,%s\n", (*m)->name, (*p)->name );
		*/
		for (f=(*p)->functions; *f; f++)
		{
		void **(*F)( void );
		
		    F = (void **(*)( void ))(*f)->monotones;
		    (*f)->monotones = (jump_addr *)F();
		}
	    }
	}
    }
#endif
}

void install_module( struct module_descr *new_module )
{
struct module_descr **s, **d, **new_table;
unsigned i, n;

    for (n=0, s=master_table; *s; s++, n++)
    {
      /* nothing */
    }

    new_table = (struct module_descr **)
    			malloc( sizeof( struct module_descr * ) * (n+2) );
    d = new_table;
    *d++ = new_module;
    s = master_table;
    while (*s)
	*d++ = *s++;
    *d++ = NULL;
    
    if (!original_modules)
	free( master_table );
    master_table = new_table;
    original_modules = NO;

    n = new_module->num_bc_extensions;
    for (i=0; i<n; i++)
      install_bc_extension( &new_module->bc_extensions[i] );
}

struct part_descr *find_part( struct module_descr *m, int tag )
{
struct part_descr **p;

    for (p=m->parts; *p; p++)
    {
	if ((*p)->tag == tag)
	{
	    /* we've found the part */
	    return *p;
	}
    }
    return NULL;
}

struct module_descr *find_module( const char *module )
{
struct module_descr **m;

    for (m=master_table; *m; m++)
    {
	if (strcmp((*m)->name,module) == 0)
	{
	    /* we've found the module */
	    return *m;
	}
    }
    return NULL;
}
