/*------------------------------------------------------------------*-C-*-*
 * File:    handc/runtime/stack.c
 *
 *          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 *          as part of the RScheme project, licensed for free use
 *
 * Version: 1.4
 * Date:    1996.04.18 20:50:04
 * Build:   v0.7-0.9, 97.01.26
 *
 * Purpose: VM stack interface
 *------------------------------------------------------------------------*/




#ifdef INCL_SCCSID
char *F5RS_dist_runtime_stack_sccsid__()
{ return "%Z%%W% 1.4 %G% 20:50:04"; }
#endif /* INCL_SCCSID */

#include <rscheme/vinsns.h>

#ifndef STACK_CACHE

#ifndef INLINES
#include <rscheme/stack.ci>
#endif


/************************ Continuations ************************/

void push_cont( jump_addr label, unsigned reg_space )
{
obj pc = alloc( SLOT(CONT_FIXED+reg_space), partcont_class );
    
    gvec_write_init( pc, SLOT(0), envt_reg );
    gvec_write_init( pc, SLOT(1), literals_reg );
    gvec_write_init( pc, SLOT(2), dynamic_state_reg );
    gvec_write_init( pc, SLOT(3), continuation_reg );
    gvec_write_init_non_ptr( pc, SLOT(4), JUMP_ADDR_TO_OBJ(label) );
    continuation_reg = pc;
}

/*
    Restores a dynamically-determined number of
    argument-passing registers (ie, for use in the
    extremely rare cases when it cannot be determined
    statically -- nb, this only happens when compiling
    to closure-threaded code and on the occasion of
    interrupts) and the continuation register itself
*/

unsigned restore_arb( void )
{
unsigned n = (SIZEOF_PTR(continuation_reg) / sizeof(obj)) - CONT_FIXED;

    restore_cont( n );
    return n;
}

#endif /* STACK_CACHE */
