#|------------------------------------------------------------*-Scheme-*--|
 | File:    test/all.scm
 |
 |          Copyright (C)1995 Donovan Kolbly <donovan@tkg.com>
 |          as part of the RScheme project, licensed for free use
 |
 | Version: 1.3
 | Date:    1996.04.18 20:15:00
 | Build:   v0.7-0.9, 97.01.26
 |
 `------------------------------------------------------------------------|#

#|
   this file should be loaded from the "test/" directory

   % cd test
   % rs all.scm
   ...
   
|#

,(use regex repl compiler)

(define $line-break (string-append (make-string 70 #\=) "\n"))

(define *errors* '())

(define (suite name)
  (display $line-break)
  (format #t "test file: ~s\n" name)
  (let ((envt (copy-top-level-contour *test-envt*)))
    (load-into envt (string-append name ".scm"))))

(define *test-envt* (make-user-initial))
(bind! *test-envt* (& *errors*))

(load-into *test-envt* "expect.scm")

(define match-suite-file
  (reg-expr->proc '(entire (seq (let name (+ (not #\.))) ".scm"))))

(define (find-suite-components)
  (let ((p (open-input-process "/bin/ls")))
    (call-with-list-extending
     (lambda (add)
       (let loop ()
	 (let ((l (read-line p)))
	   (if (eof-object? l)
	       (close-input-port p)
	       (bind ((s e name (match-suite-file l)))
		 (if (and s (not (member name '("all" "expect"))))
		     (add name))
		 (loop)))))))))

(define (run)
  (set! *errors* '())
  (for-each suite (find-suite-components))
  (if (null? *errors*)
      #t
      (begin
	(display $line-break)
	(display "ERROR SUMMARY\n")
	(for-each (lambda (e)
		    (display (reverse e))
		    (newline))
		  *errors*)
	#f)))
